/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v54</h1>       <p>Introduced in Cloudera Manager 7.11.3</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.11.3
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger.model;

import java.util.Objects;
import com.cloudera.api.swagger.model.ApiHiveTable;
import com.cloudera.api.swagger.model.ApiServiceRef;
import com.cloudera.api.swagger.model.IcebergReplicationYarnOptions;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Replication Arguments for Iceberg Replication policies
 */
@ApiModel(description = "Replication Arguments for Iceberg Replication policies")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2023-09-08T07:44:33.584Z")
public class ApiIcebergReplicationArguments {
  @SerializedName("sourceIcebergReplicationService")
  private ApiServiceRef sourceIcebergReplicationService = null;

  @SerializedName("policyName")
  private String policyName = null;

  @SerializedName("includedTableFilters")
  private List<ApiHiveTable> includedTableFilters = null;

  @SerializedName("excludedTableFilters")
  private List<ApiHiveTable> excludedTableFilters = null;

  @SerializedName("batchSize")
  private java.math.BigDecimal batchSize = null;

  @SerializedName("exportYarnOptions")
  private IcebergReplicationYarnOptions exportYarnOptions = null;

  @SerializedName("xferYarnOptions")
  private IcebergReplicationYarnOptions xferYarnOptions = null;

  @SerializedName("syncYarnOptions")
  private IcebergReplicationYarnOptions syncYarnOptions = null;

  public ApiIcebergReplicationArguments sourceIcebergReplicationService(ApiServiceRef sourceIcebergReplicationService) {
    this.sourceIcebergReplicationService = sourceIcebergReplicationService;
    return this;
  }

   /**
   * 
   * @return sourceIcebergReplicationService
  **/
  @ApiModelProperty(value = "")
  public ApiServiceRef getSourceIcebergReplicationService() {
    return sourceIcebergReplicationService;
  }

  public void setSourceIcebergReplicationService(ApiServiceRef sourceIcebergReplicationService) {
    this.sourceIcebergReplicationService = sourceIcebergReplicationService;
  }

  public ApiIcebergReplicationArguments policyName(String policyName) {
    this.policyName = policyName;
    return this;
  }

   /**
   * 
   * @return policyName
  **/
  @ApiModelProperty(value = "")
  public String getPolicyName() {
    return policyName;
  }

  public void setPolicyName(String policyName) {
    this.policyName = policyName;
  }

  public ApiIcebergReplicationArguments includedTableFilters(List<ApiHiveTable> includedTableFilters) {
    this.includedTableFilters = includedTableFilters;
    return this;
  }

  public ApiIcebergReplicationArguments addIncludedTableFiltersItem(ApiHiveTable includedTableFiltersItem) {
    if (this.includedTableFilters == null) {
      this.includedTableFilters = new ArrayList<ApiHiveTable>();
    }
    this.includedTableFilters.add(includedTableFiltersItem);
    return this;
  }

   /**
   * 
   * @return includedTableFilters
  **/
  @ApiModelProperty(value = "")
  public List<ApiHiveTable> getIncludedTableFilters() {
    return includedTableFilters;
  }

  public void setIncludedTableFilters(List<ApiHiveTable> includedTableFilters) {
    this.includedTableFilters = includedTableFilters;
  }

  public ApiIcebergReplicationArguments excludedTableFilters(List<ApiHiveTable> excludedTableFilters) {
    this.excludedTableFilters = excludedTableFilters;
    return this;
  }

  public ApiIcebergReplicationArguments addExcludedTableFiltersItem(ApiHiveTable excludedTableFiltersItem) {
    if (this.excludedTableFilters == null) {
      this.excludedTableFilters = new ArrayList<ApiHiveTable>();
    }
    this.excludedTableFilters.add(excludedTableFiltersItem);
    return this;
  }

   /**
   * 
   * @return excludedTableFilters
  **/
  @ApiModelProperty(value = "")
  public List<ApiHiveTable> getExcludedTableFilters() {
    return excludedTableFilters;
  }

  public void setExcludedTableFilters(List<ApiHiveTable> excludedTableFilters) {
    this.excludedTableFilters = excludedTableFilters;
  }

  public ApiIcebergReplicationArguments batchSize(java.math.BigDecimal batchSize) {
    this.batchSize = batchSize;
    return this;
  }

   /**
   * 
   * @return batchSize
  **/
  @ApiModelProperty(value = "")
  public java.math.BigDecimal getBatchSize() {
    return batchSize;
  }

  public void setBatchSize(java.math.BigDecimal batchSize) {
    this.batchSize = batchSize;
  }

  public ApiIcebergReplicationArguments exportYarnOptions(IcebergReplicationYarnOptions exportYarnOptions) {
    this.exportYarnOptions = exportYarnOptions;
    return this;
  }

   /**
   * 
   * @return exportYarnOptions
  **/
  @ApiModelProperty(value = "")
  public IcebergReplicationYarnOptions getExportYarnOptions() {
    return exportYarnOptions;
  }

  public void setExportYarnOptions(IcebergReplicationYarnOptions exportYarnOptions) {
    this.exportYarnOptions = exportYarnOptions;
  }

  public ApiIcebergReplicationArguments xferYarnOptions(IcebergReplicationYarnOptions xferYarnOptions) {
    this.xferYarnOptions = xferYarnOptions;
    return this;
  }

   /**
   * 
   * @return xferYarnOptions
  **/
  @ApiModelProperty(value = "")
  public IcebergReplicationYarnOptions getXferYarnOptions() {
    return xferYarnOptions;
  }

  public void setXferYarnOptions(IcebergReplicationYarnOptions xferYarnOptions) {
    this.xferYarnOptions = xferYarnOptions;
  }

  public ApiIcebergReplicationArguments syncYarnOptions(IcebergReplicationYarnOptions syncYarnOptions) {
    this.syncYarnOptions = syncYarnOptions;
    return this;
  }

   /**
   * 
   * @return syncYarnOptions
  **/
  @ApiModelProperty(value = "")
  public IcebergReplicationYarnOptions getSyncYarnOptions() {
    return syncYarnOptions;
  }

  public void setSyncYarnOptions(IcebergReplicationYarnOptions syncYarnOptions) {
    this.syncYarnOptions = syncYarnOptions;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiIcebergReplicationArguments apiIcebergReplicationArguments = (ApiIcebergReplicationArguments) o;
    return Objects.equals(this.sourceIcebergReplicationService, apiIcebergReplicationArguments.sourceIcebergReplicationService) &&
        Objects.equals(this.policyName, apiIcebergReplicationArguments.policyName) &&
        Objects.equals(this.includedTableFilters, apiIcebergReplicationArguments.includedTableFilters) &&
        Objects.equals(this.excludedTableFilters, apiIcebergReplicationArguments.excludedTableFilters) &&
        Objects.equals(this.batchSize, apiIcebergReplicationArguments.batchSize) &&
        Objects.equals(this.exportYarnOptions, apiIcebergReplicationArguments.exportYarnOptions) &&
        Objects.equals(this.xferYarnOptions, apiIcebergReplicationArguments.xferYarnOptions) &&
        Objects.equals(this.syncYarnOptions, apiIcebergReplicationArguments.syncYarnOptions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceIcebergReplicationService, policyName, includedTableFilters, excludedTableFilters, batchSize, exportYarnOptions, xferYarnOptions, syncYarnOptions);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiIcebergReplicationArguments {\n");
    
    sb.append("    sourceIcebergReplicationService: ").append(toIndentedString(sourceIcebergReplicationService)).append("\n");
    sb.append("    policyName: ").append(toIndentedString(policyName)).append("\n");
    sb.append("    includedTableFilters: ").append(toIndentedString(includedTableFilters)).append("\n");
    sb.append("    excludedTableFilters: ").append(toIndentedString(excludedTableFilters)).append("\n");
    sb.append("    batchSize: ").append(toIndentedString(batchSize)).append("\n");
    sb.append("    exportYarnOptions: ").append(toIndentedString(exportYarnOptions)).append("\n");
    sb.append("    xferYarnOptions: ").append(toIndentedString(xferYarnOptions)).append("\n");
    sb.append("    syncYarnOptions: ").append(toIndentedString(syncYarnOptions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

